diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 583e9b488..1af75351e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -5,31 +5,26 @@ import java.util.List;
 import java.util.Set;
 
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.tessellator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkRendererMultiDraw extends ChunkRenderer {
-
+    private static final @NotNull TessellatorTerrainImpl tessellatorTerrain = new TessellatorTerrainImpl(0x200000);
     public final TerrainRendererMultiDraw terrainRenderer;
     public final Entry[] renderListEntries;
 
-    public ChunkRendererMultiDraw(TerrainRendererMultiDraw terrainRenderer, World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
-        super(world, globalRenderableTileEntities, x, y, z, size, lists);
-
-        if (terrainRenderer == null) {
-            throw new NullPointerException("TerrainRenderer is null!");
-        }
+    public ChunkRendererMultiDraw(@NotNull TerrainRendererMultiDraw terrainRenderer, @NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
+        super(world, globalRenderableTileEntities, x, y, z, size);
 
         this.terrainRenderer = terrainRenderer;
         this.renderListEntries = new Entry[terrainRenderer.MAX_RENDER_PASSES];
@@ -62,7 +57,7 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 
         updates++;
 
-        TessellatorStandard tessellator = Tessellator.instance;
+        TessellatorTerrainImpl tessellator = tessellatorTerrain;
         for (int renderPass = 0; renderPass < renderPassCount; renderPass++) {
             boolean needsMoreRenderPasses = false;
             boolean hasRenderedBlock = false;
@@ -83,13 +78,6 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 
                             RenderRegion region = this.terrainRenderer.getRenderRegionAtBlockPos(this.posX, this.posZ);
                             tessellator.setTranslation(-(region.posX << this.terrainRenderer.REGION_SIZE), 0.0, -(region.posZ << this.terrainRenderer.REGION_SIZE));
-
-                            if (LightmapHelper.isLightmapEnabled()) {
-                                // Make sure it's active
-                                tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-                            }
-                            tessellator.setColorRGBA(255, 255, 255, 255);
-                            tessellator.setTextureUV(0.0, 0.0);
                         }
                         if (renderPass == 0 && Blocks.isEntityTile[blockId]) {
                             final TileEntity tileentity = chunkCache.getTileEntity(pos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
index 95afc0524..a76e31e04 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -15,149 +15,149 @@ import net.minecraft.core.util.helper.Buffer;
 
 /**
  * 		Can render a lot of objects with a single call
- * <br> All objects need to have the same {@link VertexConfig}
+ * <br> All objects need to have the same {@link VertexConfigStandard}
  * <br> Entries can be toggled visible or invisible quickly
  */
 public class RenderList {
-	private static final CategorizedLogger LOGGER = LogUtils.getLogger();
-	
-	public final VertexBuffer vertexBuffer;
-	
-	private VertexConfig vertexConfig;
-	private boolean vertexConfigLocked = false;
-	
-	private IntBuffer posBuffer;
-	private IntBuffer sizeBuffer;
-	
-	private List<Entry> entryList = new ArrayList<>();
-	private Set<Entry> visibleEntries = new HashSet<>();
-	
-	private boolean visibleEntriesUpdated = true;
-	
-	public RenderList(VertexBuffer vertexBuffer, int capacity) {
-		this.vertexBuffer = vertexBuffer;
-		this.posBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
-		this.sizeBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
-	}
-	
-	public void draw() {
-		if(entryList.size() == 0) {
+    private static final CategorizedLogger LOGGER = LogUtils.getLogger();
+
+    public final VertexBuffer vertexBuffer;
+
+    private VertexConfig<?> vertexConfig;
+    private boolean vertexConfigLocked = false;
+
+    private IntBuffer posBuffer;
+    private IntBuffer sizeBuffer;
+
+    private final List<Entry> entryList = new ArrayList<>();
+    private final Set<Entry> visibleEntries = new HashSet<>();
+
+    private boolean visibleEntriesUpdated = true;
+
+    public RenderList(VertexBuffer vertexBuffer, int capacity) {
+        this.vertexBuffer = vertexBuffer;
+        this.posBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
+        this.sizeBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
+    }
+
+    public void draw() {
+        if (this.entryList.isEmpty()) {
 //			System.out.println("No Entries!");
-			return;
-		}
-		
-		if(visibleEntriesUpdated) {
-			int vertexSize = vertexConfig.getVertexSize();
-			
-			posBuffer = expandIfNecessary(posBuffer, visibleEntries.size());
-			sizeBuffer = expandIfNecessary(sizeBuffer, visibleEntries.size());
-			
-			posBuffer.clear();
-			sizeBuffer.clear();
-			
-			for(Entry entry : visibleEntries) {
-				posBuffer.put(entry.position / vertexSize);
-				sizeBuffer.put(entry.size / vertexSize);
-			}
-			
-			posBuffer.flip();
-			sizeBuffer.flip();
-			
-			visibleEntriesUpdated = false;
-		}
-		
-		if(visibleEntries.size() == 0) {
+            return;
+        }
+
+        if (this.visibleEntriesUpdated) {
+            int vertexSize = this.vertexConfig.getVertexSize();
+
+            this.posBuffer = expandIfNecessary(this.posBuffer, this.visibleEntries.size());
+            this.sizeBuffer = expandIfNecessary(this.sizeBuffer, this.visibleEntries.size());
+
+            this.posBuffer.clear();
+            this.sizeBuffer.clear();
+
+            for (Entry entry : this.visibleEntries) {
+                this.posBuffer.put(entry.position / vertexSize);
+                this.sizeBuffer.put(entry.size / vertexSize);
+            }
+
+            this.posBuffer.flip();
+            this.sizeBuffer.flip();
+
+            this.visibleEntriesUpdated = false;
+        }
+
+        if (this.visibleEntries.isEmpty()) {
 //			System.out.println("No Visible Entries!");
-			return;
-		}
-		
+            return;
+        }
+
 //		System.out.println("Rendering " + visibleEntries.size() + " entries");
-		glMultiDrawArrays(vertexConfig.drawMode, posBuffer, sizeBuffer);
-	}
-	
-	public Entry add(VertexData vertexData, boolean visible) {
-		if(vertexData.vertexCount <= 0) {
-			return null;
-		}
-		
-		if(entryList.size() == 0 && !vertexConfigLocked) {
-			this.vertexConfig = vertexData.config.copy();
-		}else {
-			VertexConfig.compareThrow(vertexConfig, vertexData.config);
-		}
-		
-		Entry entry = vertexBuffer.addVertexData(vertexData);
-		entryList.add(entry);
-		
-		if(visible) {
-			visibleEntries.add(entry);
-			visibleEntriesUpdated = true;
-		}
-		
-		return entry;
-	}
-	
-	public void setVisible(Entry entry, boolean visible) {
-		if(entry == null) {
-			throw new NullPointerException();
-		}
-		if(visible) {
-			if(visibleEntries.add(entry)) {
-				visibleEntriesUpdated = true;
-			}
-		}else {
-			if(visibleEntries.remove(entry)) {
-				visibleEntriesUpdated = true;
-			}
-		}
-	}
-	
-	public void lockVertexConfig(VertexConfig vertexConfig) {
-		if(vertexConfig == null) {
-			throw new NullPointerException("VertexConfig cannot be null!");
-		}
-		if(entryList.size() > 0 && !this.vertexConfig.equals(vertexConfig)) {
-			VertexConfig.compareThrow(this.vertexConfig, vertexConfig);
-		}
-		this.vertexConfig = vertexConfig.copy();
-		this.vertexConfigLocked = true;
-	}
-	
-	public boolean remove(Entry entry) {
-		if(entryList.remove(entry)) {
-			vertexBuffer.removeEntry(entry);
-			visibleEntries.remove(entry);
-			visibleEntriesUpdated = true;
-			return true;
-		}
-		return false;
-	}
-	
-	public int size() {
-		return entryList.size();
-	}
-	
-	public int visibleEntryCount() {
-		return visibleEntries.size();
-	}
-	
-	public VertexConfig getVertexConfig() {
-		return vertexConfig;
-	}
-	
-	public boolean isVertexConfigLocked() {
-		return vertexConfigLocked;
-	}
-	
-	public static IntBuffer expandIfNecessary(IntBuffer buffer, int requiredCapacity) {
-		if(buffer.capacity() < requiredCapacity) {
-			int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
-			
-			LOGGER.warn("Expanding RenderList IntBuffer from " + buffer.capacity() + " to " + newCapacity + " ints...");
-			
-			return Buffer.createBuffer(newCapacity << 2).asIntBuffer();
-		}
-		return buffer;
-	}
+        glMultiDrawArrays(this.vertexConfig.drawmode().cap, this.posBuffer, this.sizeBuffer);
+    }
+
+    public Entry add(VertexData vertexData, boolean visible) {
+        if (vertexData.vertexCount <= 0) {
+            return null;
+        }
+
+        if (this.entryList.isEmpty() && !this.vertexConfigLocked) {
+            this.vertexConfig = vertexData.config.copy();
+        } else {
+            VertexConfigStandard.compareThrow(this.vertexConfig, vertexData.config);
+        }
+
+        Entry entry = this.vertexBuffer.addVertexData(vertexData);
+        this.entryList.add(entry);
+
+        if (visible) {
+            this.visibleEntries.add(entry);
+            this.visibleEntriesUpdated = true;
+        }
+
+        return entry;
+    }
+
+    public void setVisible(Entry entry, boolean visible) {
+        if (entry == null) {
+            throw new NullPointerException();
+        }
+        if (visible) {
+            if (this.visibleEntries.add(entry)) {
+                this.visibleEntriesUpdated = true;
+            }
+        } else {
+            if (this.visibleEntries.remove(entry)) {
+                this.visibleEntriesUpdated = true;
+            }
+        }
+    }
+
+    public void lockVertexConfig(VertexConfigStandard vertexConfig) {
+        if (vertexConfig == null) {
+            throw new NullPointerException("VertexConfig cannot be null!");
+        }
+        if (!this.entryList.isEmpty() && !this.vertexConfig.equals(vertexConfig)) {
+            VertexConfigStandard.compareThrow(this.vertexConfig, vertexConfig);
+        }
+        this.vertexConfig = vertexConfig.copy();
+        this.vertexConfigLocked = true;
+    }
+
+    public boolean remove(Entry entry) {
+        if (this.entryList.remove(entry)) {
+            this.vertexBuffer.removeEntry(entry);
+            this.visibleEntries.remove(entry);
+            this.visibleEntriesUpdated = true;
+            return true;
+        }
+        return false;
+    }
+
+    public int size() {
+        return this.entryList.size();
+    }
+
+    public int visibleEntryCount() {
+        return this.visibleEntries.size();
+    }
+
+    public VertexConfig<?> getVertexConfig() {
+        return this.vertexConfig;
+    }
+
+    public boolean isVertexConfigLocked() {
+        return this.vertexConfigLocked;
+    }
+
+    public static IntBuffer expandIfNecessary(IntBuffer buffer, int requiredCapacity) {
+        if (buffer.capacity() < requiredCapacity) {
+            int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
+
+            LOGGER.warn("Expanding RenderList IntBuffer from {} to {} ints...", buffer.capacity(), newCapacity);
+
+            return Buffer.createBuffer(newCapacity << 2).asIntBuffer();
+        }
+        return buffer;
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
index 78b6c85ee..bfafe0bfb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
@@ -18,6 +18,6 @@ public abstract class TerrainRenderer {
 	
 	public abstract void renderTranslucentTerrain(float partialTicks);
 	
-	public abstract ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists);
+	public abstract ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size);
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index 2a1a6470d..e1df10235 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -1,268 +1,245 @@
 package net.minecraft.client.render.terrain;
 
-import static org.lwjgl.opengl.GL11.*;
-
+import java.util.Arrays;
 import java.util.List;
 
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.core.block.entity.TileEntity;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
-import net.minecraft.client.render.tessellator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class TerrainRendererMultiDraw extends TerrainRenderer {
 
-	public final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
-	
-	public final int RENDER_LIST_INITIAL_CAPACITY = 2048;
-	
-	/**
-	 * Exponential Region Size
-	 * Lower Region Size: More Draw Calls, reduced FPS
-	 * Higher Region Size: More Visual Artifacts
-	 */
-	public final int REGION_SIZE = 9;
-	
-	public final int MAX_RENDER_PASSES = 2;
-	
-	/**
-	 * For debugging purposes
-	 */
-	public final boolean DISABLE_REGION_OFFSET = false;
-	
-	public VertexBuffer vertexBuffer;
-	public RegionBuffer regionBuffer;
-	
-	private VertexConfig terrainVertexConfig;
-	
-	int[] drawCalls = new int[MAX_RENDER_PASSES];
-	
-	private double renderPosX;
-	private double renderPosY;
-	private double renderPosZ;
-
-	private double prevSortX;
-	private double prevSortY;
-	private double prevSortZ;
-	
-	public TerrainRendererMultiDraw(Minecraft minecraft) {
-		super(minecraft);
-		
-		vertexBuffer = new VertexBuffer(VERTEX_BUFFER_INITIAL_CAPACITY);
-		regionBuffer = new RegionBuffer(REGION_SIZE);
-	}
-	
-	@Override
-	public void renderSolidTerrain(float partialTicks) {
-		for(int i=0; i < drawCalls.length; i++) {
-			drawCalls[i] = 0;
-		}
-
-		ICamera camera = mc.activeCamera;
-		renderPosX = camera.getX(partialTicks);
-		renderPosY = camera.getY(partialTicks);
-		renderPosZ = camera.getZ(partialTicks);
-
-		double dX = renderPosX - prevSortX;
-		double dY = renderPosY - prevSortY;
-		double dZ = renderPosZ - prevSortZ;
-
-		if(dX * dX + dY * dY + dZ * dZ > 16.0) {
-			prevSortX = renderPosX;
-			prevSortY = renderPosY;
-			prevSortZ = renderPosZ;
-			
-			int x = MathHelper.floor(renderPosX);
-			int y = MathHelper.floor(renderPosY);
-			int z = MathHelper.floor(renderPosZ);
-			
-			mc.renderGlobal.resortChunks(x, y, z);
-		}
-		
-		if(terrainVertexConfig == null) {
-			return;
-		}
-
-		terrainVertexConfig.enableVBO(vertexBuffer.getVbo());
-		
-		List<RenderRegion> regions = regionBuffer.getAllRegions();
-		for(int i=0; i < regions.size(); i++) {
-			RenderRegion region = regions.get(i);
-			// TODO Clear empty regions, but not like this
+    public final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
+
+    public final int RENDER_LIST_INITIAL_CAPACITY = 4096;
+
+    /**
+     * Exponential Region Size
+     * Lower Region Size: More Draw Calls, reduced FPS
+     * Higher Region Size: More Visual Artifacts
+     */
+    public final int REGION_SIZE = 9;
+
+    public final int MAX_RENDER_PASSES = 2;
+
+    public VertexBuffer vertexBuffer;
+    public RegionBuffer regionBuffer;
+
+    private VertexConfig<?> terrainVertexConfig;
+
+    int[] drawCalls = new int[this.MAX_RENDER_PASSES];
+
+    private double renderPosX;
+    private double renderPosY;
+    private double renderPosZ;
+
+    private double prevSortX;
+    private double prevSortY;
+    private double prevSortZ;
+
+    public TerrainRendererMultiDraw(Minecraft minecraft) {
+        super(minecraft);
+
+        this.vertexBuffer = new VertexBuffer(this.VERTEX_BUFFER_INITIAL_CAPACITY);
+        this.regionBuffer = new RegionBuffer(this.REGION_SIZE);
+    }
+
+    @Override
+    public void renderSolidTerrain(float partialTicks) {
+        Arrays.fill(this.drawCalls, 0);
+
+        ICamera camera = this.mc.activeCamera;
+        this.renderPosX = camera.getX(partialTicks);
+        this.renderPosY = camera.getY(partialTicks);
+        this.renderPosZ = camera.getZ(partialTicks);
+
+        double dX = this.renderPosX - this.prevSortX;
+        double dY = this.renderPosY - this.prevSortY;
+        double dZ = this.renderPosZ - this.prevSortZ;
+
+        if (dX * dX + dY * dY + dZ * dZ > 64) {
+            this.prevSortX = this.renderPosX;
+            this.prevSortY = this.renderPosY;
+            this.prevSortZ = this.renderPosZ;
+
+            int x = MathHelper.floor(this.renderPosX);
+            int y = MathHelper.floor(this.renderPosY);
+            int z = MathHelper.floor(this.renderPosZ);
+
+            this.mc.renderGlobal.resortChunks(x, y, z);
+        }
+
+        if (this.terrainVertexConfig == null) {
+            return;
+        }
+
+        this.terrainVertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
+
+        List<RenderRegion> regions = this.regionBuffer.getAllRegions();
+        for (int i = 0; i < regions.size(); i++) {
+            RenderRegion region = regions.get(i);
+            // TODO Clear empty regions, but not like this
 //			if(!region.hasRenderData()) {
 //				regionBuffer.remove(region);
 //				i--;
 //				continue;
 //			}
 
-			RenderList renderList = region.renderLists[0];
-			if(renderList != null && renderList.size() > 0) {
-				if(!DISABLE_REGION_OFFSET) {
-					glPushMatrix();
-					glTranslated((region.posX << REGION_SIZE) - renderPosX, -renderPosY, (region.posZ << REGION_SIZE) - renderPosZ);
-				} else {
-					glPushMatrix();
-					glTranslated( - renderPosX, -renderPosY, -renderPosZ);
-				}
-				
-				renderList.draw();
-				drawCalls[0]++;
-				
-				if(!DISABLE_REGION_OFFSET) {
-					glPopMatrix();
-				} else {
-					glPopMatrix();
-				}
-			}
-		}
-		
-		terrainVertexConfig.disable();
-	}
-	
-	public void renderAllLists(int renderPass) {
-		List<RenderRegion> regions = regionBuffer.getAllRegions();
-		for(int i=0; i < regions.size(); i++) {
-			RenderRegion region = regions.get(i);
-			RenderList renderList = region.renderLists[renderPass];
-			if(renderList != null && renderList.size() > 0) {
-				if(!DISABLE_REGION_OFFSET) {
-					glPushMatrix();
-					glTranslated((region.posX << REGION_SIZE) - renderPosX, -renderPosY, (region.posZ << REGION_SIZE) - renderPosZ);
-				} else {
-					glPushMatrix();
-					glTranslated( - renderPosX, -renderPosY, -renderPosZ);
-				}
-				
-				renderList.draw();
-				drawCalls[renderPass]++;
-				
-				if(!DISABLE_REGION_OFFSET) {
-					glPopMatrix();
-				} else {
-					glPopMatrix();
-				}
-			}
-		}
-	}
-
-	@Override
-	public void renderTranslucentTerrain(float partialTicks) {
-		if(terrainVertexConfig == null) {
-			return;
-		}
-
-		terrainVertexConfig.enableVBO(vertexBuffer.getVbo());
-		
-		boolean fancy = mc.gameSettings.fancyGraphics.value != 0;
-		
-		if(fancy) {
-			GL11.glColorMask(false, false, false, false);
-		}
-		
-		renderAllLists(1);
-		
-		if(fancy) {
-			GL11.glColorMask(true, true, true, true);
-			if(drawCalls[1] > 0) {
-				renderAllLists(1);
-			}
-		}
-		
-		terrainVertexConfig.disable();
-	}
-	
-	public void chunkRendered(ChunkRendererMultiDraw chunkRenderer, TessellatorStandard tessellator, final int renderPass) {
-		tessellator.drawing = false;
-		VertexConfig config = tessellator.data.config;
-		
-		if(terrainVertexConfig == null) {
-			this.terrainVertexConfig = config.copy();
-		}else {
-			if(!this.terrainVertexConfig.equals(tessellator.data.config)) {
-				List<RenderRegion> allRegions = regionBuffer.getAllRegions();
-				for(int i=0; i < allRegions.size(); i++) {
-					RenderRegion region = allRegions.get(i);
-					if(region.hasRenderData()) {
-						VertexConfig.compareThrow(tessellator.data.config, terrainVertexConfig);
-					}
-					regionBuffer.remove(region);
-					i--;
-				}
-				
-				this.terrainVertexConfig = config.copy();
-			}
-		}
-		
-		RenderList renderList = getOrCreateRenderList(chunkRenderer, renderPass);
-		Entry entry = renderList.add(tessellator.data, chunkRenderer.visible);
-		chunkRenderer.renderListEntries[renderPass] = entry;
-	}
-	
-	public void chunkVisibilityChanged(ChunkRendererMultiDraw chunkRenderer) {
-		RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
-		
-		for(int renderPass=0; renderPass < MAX_RENDER_PASSES; renderPass++) {
-			Entry entry = chunkRenderer.renderListEntries[renderPass];
-			if(entry == null) {
-				continue;
-			}
-			RenderList renderList = region.renderLists[renderPass];
-			if(renderList == null) {
-				throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
-			}
-			renderList.setVisible(entry, chunkRenderer.visible);
-		}
-	}
-	
-	public void chunkDeleted(ChunkRendererMultiDraw chunkRenderer) {
-		RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
-		for(int renderPass=0; renderPass < MAX_RENDER_PASSES; renderPass++) {
-			Entry entry = chunkRenderer.renderListEntries[renderPass];
-			if(entry == null) {
-				continue;
-			}
-			RenderList renderList = region.renderLists[renderPass];
-			if(renderList == null) {
-				throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
-			}
-			renderList.remove(entry);
-			chunkRenderer.renderListEntries[renderPass] = null;
-		}
-	}
-	
-	public RenderList getOrCreateRenderList(ChunkRendererMultiDraw chunkRenderer, final int renderPass) {
-		return getOrCreateRenderList(chunkRenderer.posX, chunkRenderer.posZ, renderPass);
-	}
-	
-	public RenderList getOrCreateRenderList(int posX, int posZ, final int renderPass) {
-		RenderRegion region = regionBuffer.getRegionAtBlockPos(posX, posZ);
-		RenderList renderList = region.renderLists[renderPass];
-		if(renderList == null) {
-			renderList = new RenderList(vertexBuffer, RENDER_LIST_INITIAL_CAPACITY);
-			region.renderLists[renderPass] = renderList;
-		}
-		return renderList;
-	}
-
-	@Override
-	public ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
-		return new ChunkRendererMultiDraw(this, world, globalRenderableTileEntities, x, y, z, size, lists);
-	}
-	
-	public RenderRegion getRenderRegionAtBlockPos(int blockX, int blockZ) {
-		return regionBuffer.getRegionAtBlockPos(blockX, blockZ);
-	}
-	
-	public int getTotalDrawCalls() {
-		int totalDrawCalls = 0;
-		for(int i=0; i < drawCalls.length; i++) {
-			totalDrawCalls += drawCalls[i];
-		}
-		return totalDrawCalls;
-	}
-	
+            RenderList renderList = region.renderLists[0];
+            if (renderList != null && renderList.size() > 0) {
+                GLRenderer.pushFrame();
+                GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
+                GLRenderer.globalSetUniforms(Shaders.WORLD);
+
+                renderList.draw();
+                this.drawCalls[0]++;
+
+                GLRenderer.popFrame();
+            }
+        }
+
+        this.terrainVertexConfig.disable();
+    }
+
+    public void renderAllLists(int renderPass) {
+        List<RenderRegion> regions = this.regionBuffer.getAllRegions();
+        for (int i = 0; i < regions.size(); i++) {
+            RenderRegion region = regions.get(i);
+            RenderList renderList = region.renderLists[renderPass];
+            if (renderList != null && renderList.size() > 0) {
+                GLRenderer.pushFrame();
+                GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
+                GLRenderer.globalSetUniforms(Shaders.WORLD);
+
+                renderList.draw();
+                this.drawCalls[renderPass]++;
+
+                GLRenderer.popFrame();
+            }
+        }
+    }
+
+    @Override
+    public void renderTranslucentTerrain(float partialTicks) {
+        if (this.terrainVertexConfig == null) {
+            return;
+        }
+
+        this.terrainVertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
+
+        boolean fancy = this.mc.gameSettings.fancyGraphics.value != 0;
+
+        if (fancy) {
+            GLRenderer.setColorMask(false, false, false, false);
+        }
+
+        renderAllLists(1);
+
+        if (fancy) {
+            GLRenderer.setColorMask(true, true, true, true);
+            if (this.drawCalls[1] > 0) {
+                renderAllLists(1);
+            }
+        }
+
+        this.terrainVertexConfig.disable();
+    }
+
+    public void chunkRendered(ChunkRendererMultiDraw chunkRenderer, TessellatorTerrainImpl tessellator, final int renderPass) {
+        tessellator.drawing = false;
+        VertexConfig<?> config = tessellator.data.config;
+
+        if (this.terrainVertexConfig == null) {
+            this.terrainVertexConfig = config.copy();
+        } else {
+            if (!this.terrainVertexConfig.equals(tessellator.data.config)) {
+                List<RenderRegion> allRegions = this.regionBuffer.getAllRegions();
+                for (int i = 0; i < allRegions.size(); i++) {
+                    RenderRegion region = allRegions.get(i);
+                    if (region.hasRenderData()) {
+                        VertexConfigStandard.compareThrow(tessellator.data.config, this.terrainVertexConfig);
+                    }
+                    this.regionBuffer.remove(region);
+                    i--;
+                }
+
+                this.terrainVertexConfig = config.copy();
+            }
+        }
+
+        RenderList renderList = getOrCreateRenderList(chunkRenderer, renderPass);
+        Entry entry = renderList.add(tessellator.data, chunkRenderer.visible);
+        chunkRenderer.renderListEntries[renderPass] = entry;
+    }
+
+    public void chunkVisibilityChanged(ChunkRendererMultiDraw chunkRenderer) {
+        RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
+
+        for (int renderPass = 0; renderPass < this.MAX_RENDER_PASSES; renderPass++) {
+            Entry entry = chunkRenderer.renderListEntries[renderPass];
+            if (entry == null) {
+                continue;
+            }
+            RenderList renderList = region.renderLists[renderPass];
+            if (renderList == null) {
+                throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+            }
+            renderList.setVisible(entry, chunkRenderer.visible);
+        }
+    }
+
+    public void chunkDeleted(ChunkRendererMultiDraw chunkRenderer) {
+        RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
+        for (int renderPass = 0; renderPass < this.MAX_RENDER_PASSES; renderPass++) {
+            Entry entry = chunkRenderer.renderListEntries[renderPass];
+            if (entry == null) {
+                continue;
+            }
+            RenderList renderList = region.renderLists[renderPass];
+            if (renderList == null) {
+                throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+            }
+            renderList.remove(entry);
+            chunkRenderer.renderListEntries[renderPass] = null;
+        }
+    }
+
+    public RenderList getOrCreateRenderList(ChunkRendererMultiDraw chunkRenderer, final int renderPass) {
+        return getOrCreateRenderList(chunkRenderer.posX, chunkRenderer.posZ, renderPass);
+    }
+
+    public RenderList getOrCreateRenderList(int posX, int posZ, final int renderPass) {
+        RenderRegion region = this.regionBuffer.getRegionAtBlockPos(posX, posZ);
+        RenderList renderList = region.renderLists[renderPass];
+        if (renderList == null) {
+            renderList = new RenderList(this.vertexBuffer, this.RENDER_LIST_INITIAL_CAPACITY);
+            region.renderLists[renderPass] = renderList;
+        }
+        return renderList;
+    }
+
+    @Override
+    public ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
+        return new ChunkRendererMultiDraw(this, world, globalRenderableTileEntities, x, y, z, size);
+    }
+
+    public RenderRegion getRenderRegionAtBlockPos(int blockX, int blockZ) {
+        return this.regionBuffer.getRegionAtBlockPos(blockX, blockZ);
+    }
+
+    public int getTotalDrawCalls() {
+        int totalDrawCalls = 0;
+        for (int i = 0; i < this.drawCalls.length; i++) {
+            totalDrawCalls += this.drawCalls[i];
+        }
+        return totalDrawCalls;
+    }
+
 }
